> For the complete documentation index, see [llms.txt](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/oaa/python-sdk/oaaclient-modules/structures.md).

# Structures

Data structures supporting the OAA templates.

Case-insensitive collection types used to track entities such as local users, groups, roles and resources by name or unique ID.

Copyright 2023 Veza Technologies Inc.

Use of this source code is governed by the MIT license that can be found in the LICENSE file or at <https://opensource.org/licenses/MIT>.

***

## <kbd>class</kbd> `CaseInsensitiveDict`

Case Insensitive Key Dictionary

Dictionary like object with case insensitive keys for types that support `.lower()` such as strings.

Keys do not have to be strings, in the case where the key type does not support `.lower()` such as integers the value is used as is.

**Example:** `from oaaclient.structures import CaseInsensitiveDict` >>> x = CaseInsensitiveDict() >>> x\["User"] = "value" >>> x.get("user") 'value' >>> "USER" in x True >>> print(x) {'user': 'value'} >>> x CaseInsensitiveDict({'user': 'value'})

### <kbd>method</kbd> `__init__`

```python
__init__(data=None, **kwargs) → None
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.veza.com/4yItIzMvkpAvMVFAamTf/developers/api/oaa/python-sdk/oaaclient-modules/structures.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
